/* AMX Mod script. 
* 
* Bill Gates - (Based on Alternate Shop by SniperBeamer)
*	Made By AssKicR
* 
* CVARs: 
*  gates_buytime - take care of buytime (0/1) 
*  mp_buytime - sets buytime (minutes) 
*  gates_buyzone - take care of buyzone (0/1) 
*  gates_buyteam - take care of team (0/1) 
*  gates_buymulti - buy more than on sec/prim weapon (0/1) 
*  gates_buygrenades - Limit to how many He he can buy?
*  gates_money - how much cash gates starts with every round
* 
* Commands used by gates: 
*  buy
*  buyequip
*  buyammo1
*  buyammo2
* 
*/ 
//---------------------------------------------------------------------------------------------- 
#include <amxmodx> 
#include <amxmisc> 
#include <fun>
#include <cstrike>
#include <superheromod> 
//---------------------------------------------------------------------------------------------- 
new wCost[31] 

new bool:BuyTimeAllow 
new bool:BuyZoneAllow[33] 
new BuyProtect[33] 
new Float:BuyTimeFloat 
new BuyTimeNum 
new bool:BuyTimeCvar 
new bool:BuyZoneCvar 
new bool:BuyTeamCvar 
new bool:BuyMultiCvar 
new BuyGrenadesCvar 
new bool:DeMap 

new bool:KevlarHelmet[33] 
new bool:DefuseKit[33] 

new gmsgFade 
new bool:NightVision[33]
new bool:NightVisionUse[33] 

new gHeroName[]="Bill Gates"
new bool:gHasBillGatesPowers[SH_MAXSLOTS+1]
//---------------------------------------------------------------------------------------------- 
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Bill Gates","2.0","AssKicR")
 
  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create Bill Gates Hero")
  if (!cvar_exists("gates_level")) register_cvar("gates_level", "6" )
  new desc[200]
  new descBuyTime[4]="NO", descBuyZone[4]="NO", descBuyTeam[4]="NO", descBuyMulti[4]="NO"
  if (get_cvar_num("gates_buytime")==0) format(descBuyTime,3,"YES")
  if (get_cvar_num("gates_buyzone")==0) format(descBuyZone,3,"YES")
  if (get_cvar_num("gates_buyteam")==0) format(descBuyTeam,3,"YES")
  if (get_cvar_num("gates_buymulti")==1) format(descBuyMulti,3,"YES")
  format(desc, 199, "Can Buy All Weapons=%s , Can Buy Outside BuyZones=%s , Can Buy After Buytime Runs Out=%s , Can Buy Multiple Weapons=%s",descBuyTeam,descBuyZone,descBuyTime,descBuyMulti)
  shCreateHero(gHeroName, "Windows Buymenu", desc, false, "gates_level" )
  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  
  // INIT
  register_srvcmd("gates_init", "gates_init")
  shRegHeroInit(gHeroName, "gates_init")
  //REGISTER ROUNDTIME
  register_event("RoundTime","Round_Time","bc") 
  //REGISTER RESTART ROUND
  register_event("TextMsg","Restart_Round","a","2&#Game_C","2&#Game_w") 
  //REGISTER BUYZONE & DEFUSEKIT
  register_event("StatusIcon","Buy_Icon","be","2=buyzone") 
  register_event("StatusIcon","DefKit_Icon","be","2=defuser") 
  //RTEGISTER CVARS
  register_cvar("gates_buytime","1") 
  register_cvar("gates_buyzone","0") 
  register_cvar("gates_buyteam","0") 
  register_cvar("gates_buymulti","0")
  register_cvar("gates_buygrenades","0") 
  register_cvar("gates_money","32000")
  //REGISTER NEWROUND
  register_event("ResetHUD","newRound","b")
  register_event("ResetHUD","New_Round","b") 
  //REGISTER DEATH
  register_event("DeathMsg","Player_Death","a")
  //REGISTER GATES BUYMENU
  register_clcmd("buy","BuyMenu") 
  register_clcmd("buyequip","EquipMenu") 
  register_clcmd("buyammo1","PriTask") 
  register_clcmd("buyammo2","SecTask")
  //REGISTER NIGHTVISION
  register_clcmd("nightvision","ToggleNVG") 
  gmsgFade = get_user_msgid("ScreenFade") 
  //REGISTER SUBMENUS
  register_menucmd(register_menuid("Buy Item"),1023,"BuyMenuAction") 
  register_menucmd(register_menuid("Buy Handgun"),1023,"HandMenuAction") 
  register_menucmd(register_menuid("Buy Shotgun"),1023,"ShotMenuAction") 
  register_menucmd(register_menuid("Buy Sub-Machine Gun"),1023,"SubMenuAction") 
  register_menucmd(register_menuid("Buy Assault Rifle"),1023,"RifleMenuAction") 
  register_menucmd(register_menuid("Buy Machine Gun"),1023,"MachineMenuAction") 
  register_menucmd(register_menuid("Buy Equipment"),1023,"EquipMenuAction")
  // check if is de_ map 
  new cMap[32] 
  get_mapname(cMap,31) 
  if ( equali(cMap,"de_",3)||equali(cMap,"csde_",5) ) DeMap = true 
  else DeMap = false 
  //SET COSTS OF GUNS
  setCost()
  }
//----------------------------------------------------------------------------------------------
public gates_init()
{
  new temp[6]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)
  
  // 2nd Argument is 0 or 1 depending on whether the id has gates skills
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  if ( hasPowers ) {
    gHasBillGatesPowers[id]=true
    new descBuyTime[4]="NO", descBuyZone[4]="NO", descBuyTeam[4]="NO", descBuyMulti[4]="NO"
    if (get_cvar_num("gates_buytime")==0) format(descBuyTime,3,"YES")
    if (get_cvar_num("gates_buyzone")==0) format(descBuyZone,3,"YES")
    if (get_cvar_num("gates_buyteam")==0) format(descBuyTeam,3,"YES")
    if (get_cvar_num("gates_buymulti")==1) format(descBuyMulti,3,"YES")
    client_print(id,print_chat,"[BILL] Can Buy All Weapons=%s ,Can Buy Outside BuyZones=%s ,Can Buy After Buytime Runs Out=%s ,Can Buy Multiple Weapons=%s",descBuyTeam,descBuyZone,descBuyTime,descBuyMulti)
  }else{
    gHasBillGatesPowers[id]=false  
  }
}
//----------------------------------------------------------------------------------------------

public newRound(id) 
{ 
   if (gHasBillGatesPowers[id]) {
   cs_set_user_money(id,get_cvar_num("gates_money"))
   }
} 
//---------------------------------------------------------------------------------------------- 
public client_connect(id) // reset some settings 
{ 
   KevlarHelmet[id] = false // no Kevlar&Helmet is bought
   NightVision[id] = false // cannot use NightVision 
} 
//---------------------------------------------------------------------------------------------- 
public client_disconnect(id) 
{ 
   if (NightVisionUse[id]) StopNVG(id) // stop NightVision 
} 
//---------------------------------------------------------------------------------------------- 
public Round_Time() 
{ 
   if ( read_data(1)==get_cvar_num("mp_freezetime") || read_data(1)==6 ) // freezetime starts 
   { 
      remove_task(701) // remove buytime task 
      BuyTimeAllow = true 
      BuyTimeFloat = get_cvar_float("mp_buytime") * 60 
      BuyTimeNum = floatround(BuyTimeFloat,floatround_floor) 
      BuyTimeCvar = (get_cvar_num("gates_buytime")) ? true : false 
      BuyZoneCvar = (get_cvar_num("gates_buyzone")) ? true : false 
      BuyTeamCvar = (get_cvar_num("gates_buyteam")) ? true : false 
      BuyMultiCvar = (get_cvar_num("gates_buymulti")) ? true : false 
      BuyGrenadesCvar = get_cvar_num("gates_buygrenades") 
   } 
   else // freezetime is over 
   { 
      set_task(BuyTimeFloat,"BuyTimeTask",701) 
   } 

   return PLUGIN_CONTINUE 
} 
//---------------------------------------------------------------------------------------------- 
public BuyTimeTask() 
{ 
   BuyTimeAllow = false // buytime is over 
} 
//---------------------------------------------------------------------------------------------- 
public Buy_Icon(id) // player is in buyzone? 
{ 
   if (read_data(1)) 
   { 
      BuyZoneAllow[id] = true 
   } 
   else 
   { 
      BuyZoneAllow[id] = false 
   } 

   return PLUGIN_CONTINUE 
} 
//---------------------------------------------------------------------------------------------- 
public DefKit_Icon(id) // player has a defusekit? 
{ 
   if (read_data(1)) 
   { 
      DefuseKit[id] = true 
   } 
   else 
   { 
      DefuseKit[id] = false 
   } 

   return PLUGIN_CONTINUE 
} 
//---------------------------------------------------------------------------------------------- 
public New_Round(id) 
{ 
   BuyProtect[id] = 0 // reset bought HEs 
   KevlarHelmet[id] = false // no Kevlar&Helmet is bought 
   if (NightVisionUse[id]) StopNVG(id) // stop NightVision 

   return PLUGIN_CONTINUE 
} 
//---------------------------------------------------------------------------------------------- 
public Player_Death() 
{ 
   new victim_id = read_data(2)
   NightVision[victim_id] = false 
   if (NightVisionUse[victim_id]) StopNVG(victim_id) // stop NightVision 

   return PLUGIN_CONTINUE 
} 
//---------------------------------------------------------------------------------------------- 
public Check(id) // check if player can buy 
{ 
   if ( !is_user_alive(id) || (!BuyZoneAllow[id]&&BuyZoneCvar) || !gHasBillGatesPowers[id] ) 
      return false 
   if (BuyTimeCvar) 
   { 
      if (!CheckTime(id)) 
         return false 
   } 
   return true 
} 
//---------------------------------------------------------------------------------------------- 
public CheckTime(id) // check buytime 
{ 
   if (!BuyTimeAllow) 
   { 
      client_print(id,print_center,"%d seconds have passed...^n^nYou can't buy anything now!",BuyTimeNum) 
      return false 
   } 
   return true 
} 
//---------------------------------------------------------------------------------------------- 
public Money(id,num) // check money 
{ 
   new userMoney = cs_get_user_money(id)-wCost[num] 

   if (userMoney < 0) 
   { 
      client_print(id,print_center,"You have insufficient funds!") 
      return false 
   } 
   cs_set_user_money(id,userMoney) 

   return true 
} 
//---------------------------------------------------------------------------------------------- 
public PrimWeapon(id,bid,bnum) // buy primary weapon 
{ 
   new weapons[32],num,dropW 
   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
      if (weapons[i]==bid) // abort if already have this weapon 
         return PLUGIN_HANDLED 

   if (!Money(id,bnum)) return PLUGIN_HANDLED 

   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
      if (isPrimary(weapons[i])) 
      { 
         dropW = weapons[i] // save primary weapon 
         break 
      } 

   GiveWeapon(id,bid,dropW) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public SecWeapon(id,bid,bnum) // buy secondary weapon 
{ 
   new weapons[32],num,dropW 
   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
      if (weapons[i]==bid) // abort if already have this weapon 
         return PLUGIN_HANDLED 

   if (!Money(id,bnum)) return PLUGIN_HANDLED 

   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
      if (isSecondary(weapons[i])) 
      { 
         dropW = weapons[i] // save secondary weapon 
         break 
      } 

   GiveWeapon(id,bid,dropW) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public GiveWeapon(id,weapon,dropW) // give weapon 
{ 
   new weapons[32],num 
   get_user_weapons(id,weapons,num) 

   new wpName[24] 
   get_weaponname(weapon,wpName,23) 

   if (is_user_alive(id)) shGiveWeapon(id,wpName) 

   if (dropW!=0&&!BuyMultiCvar) DropWeapon(id,dropW) 
} 
//---------------------------------------------------------------------------------------------- 
public DropWeapon(id,weapon) // drop weapon saved before 
{ 
   new wpName[24] 
   get_weaponname(weapon,wpName,23) 
   client_cmd(id,"drop %s",wpName) 
} 
//---------------------------------------------------------------------------------------------- 
public isPrimary(weapon) // check if weapon is primary 
{ 
   if (weapon==CSW_M3||weapon==CSW_XM1014||weapon==CSW_MP5NAVY||weapon==CSW_TMP||weapon==CSW_P90||weapon==CSW_MAC10 
    ||weapon==CSW_UMP45||weapon==CSW_AK47||weapon==CSW_SG552||weapon==CSW_M4A1||weapon==CSW_AUG||weapon==CSW_SCOUT 
    ||weapon==CSW_AWP||weapon==CSW_G3SG1||weapon==CSW_SG550||weapon==CSW_M249) 
      return true 
   return false 
} 
//---------------------------------------------------------------------------------------------- 
public isSecondary(weapon) // check if weapon is secondary 
{ 
   if (weapon==CSW_USP||weapon==CSW_GLOCK18||weapon==CSW_DEAGLE||weapon==CSW_P228||weapon==CSW_ELITE||weapon==CSW_FIVESEVEN) 
      return true 
   return false 
} 
//---------------------------------------------------------------------------------------------- 
public CheckMaxPriAmmo(id) // check if primary ammo is full 
{ 
   new weapons[32],num,clip,cammo 
   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
   { 
      get_user_ammo(id,weapons[i],clip,cammo) 
      switch (weapons[i]) 
      { 
         case CSW_M3:      if (!(clip+cammo==40)) return true 
         case CSW_XM1014:   if (!(clip+cammo==39)) return true 
         case CSW_MP5NAVY:   if (!(clip+cammo==150)) return true 
         case CSW_TMP:      if (!(clip+cammo==150)) return true 
         case CSW_P90:      if (!(clip+cammo==150)) return true 
         case CSW_MAC10:      if (!(clip+cammo==130)) return true 
         case CSW_UMP45:      if (!(clip+cammo==125)) return true 
         case CSW_AK47:      if (!(clip+cammo==120)) return true 
         case CSW_SG552:      if (!(clip+cammo==120)) return true 
         case CSW_M4A1:      if (!(clip+cammo==120)) return true 
         case CSW_AUG:      if (!(clip+cammo==120)) return true 
         case CSW_SCOUT:      if (!(clip+cammo==100)) return true 
         case CSW_AWP:      if (!(clip+cammo==40)) return true 
         case CSW_G3SG1:      if (!(clip+cammo==110)) return true 
         case CSW_SG550:      if (!(clip+cammo==120)) return true 
         case CSW_M249:      if (!(clip+cammo==300)) return true 
      } 
   } 
   return false 
} 
//---------------------------------------------------------------------------------------------- 
public CheckMaxSecAmmo(id) // check if secondary ammo is full 
{ 
   new weapons[32],num,clip,cammo 
   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
   { 
      get_user_ammo(id,weapons[i],clip,cammo) 
      switch (weapons[i]) 
      { 
         case CSW_USP:      if (!(clip+cammo==112)) return true 
         case CSW_GLOCK18:   if (!(clip+cammo==140)) return true 
         case CSW_DEAGLE:   if (!(clip+cammo==42)) return true 
         case CSW_P228:      if (!(clip+cammo==65)) return true 
         case CSW_ELITE:      if (!(clip+cammo==150)) return true 
         case CSW_FIVESEVEN:   if (!(clip+cammo==120)) return true 
      } 
   } 
   return false 
} 
//---------------------------------------------------------------------------------------------- 
public PriTask(id) // task for buying primary ammo (because of buyscripts) 
{ 
   if (!gHasBillGatesPowers[id]) return PLUGIN_CONTINUE
   new ids[3] 
   num_to_str(id,ids,3) 
   set_task(0.1,"PrimaryAmmo",0,ids,3) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public SecTask(id) // task for buying secondary ammo (because of buyscripts) 
{ 
   if (!gHasBillGatesPowers[id]) return PLUGIN_CONTINUE
   new ids[3] 
   num_to_str(id,ids,3) 
   set_task(0.1,"SecondaryAmmo",0,ids,3) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public PrimaryAmmo(ids[]) // give primary ammo 
{ 
   new id = str_to_num(ids) 

   if (!Check(id) || !CheckMaxPriAmmo(id)) return PLUGIN_HANDLED 
   if (!Money(id,22)) return PLUGIN_HANDLED 

   new weapons[32],num 
   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
      switch (weapons[i]) 
      { 
         case CSW_M3:      give_item(id,"ammo_buckshot") 
         case CSW_XM1014:   give_item(id,"ammo_buckshot") 
         case CSW_MP5NAVY:   give_item(id,"ammo_9mm") 
         case CSW_TMP:      give_item(id,"ammo_9mm") 
         case CSW_P90:      give_item(id,"ammo_57mm") 
         case CSW_MAC10:      give_item(id,"ammo_45acp") 
         case CSW_UMP45:      give_item(id,"ammo_45acp") 
         case CSW_AK47:      give_item(id,"ammo_762nato") 
         case CSW_SG552:      give_item(id,"ammo_556nato") 
         case CSW_M4A1:      give_item(id,"ammo_556nato") 
         case CSW_AUG:      give_item(id,"ammo_556nato") 
         case CSW_SCOUT:      give_item(id,"ammo_762nato") 
         case CSW_AWP:      give_item(id,"ammo_338magnum") 
         case CSW_G3SG1:      give_item(id,"ammo_762nato") 
         case CSW_SG550:      give_item(id,"ammo_556nato") 
         case CSW_M249:      give_item(id,"ammo_556natobox") 
      } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public SecondaryAmmo(ids[]) // give secondary ammo 
{ 
   new id = str_to_num(ids) 

   if (!Check(id) || !CheckMaxSecAmmo(id)) return PLUGIN_HANDLED 
   if (!Money(id,23)) return PLUGIN_HANDLED 

   new weapons[32],num 
   get_user_weapons(id,weapons,num) 
   for (new i=0; i<num; i++) 
      switch (weapons[i]) 
      { 
         case CSW_USP:      give_item(id,"ammo_45acp") 
         case CSW_GLOCK18:   give_item(id,"ammo_9mm") 
         case CSW_DEAGLE:   give_item(id,"ammo_50ae") 
         case CSW_P228:      give_item(id,"ammo_357sig") 
         case CSW_ELITE:      give_item(id,"ammo_9mm") 
         case CSW_FIVESEVEN:   give_item(id,"ammo_57mm") 
      } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public BuyMenuAction(id,key) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE 

   switch (key){ 
      case 0: HandMenu(id) 
      case 1: ShotMenu(id) 
      case 2: SubMenu(id) 
      case 3: RifleMenu(id) 
      case 4: MachineMenu(id) 
      case 5: PriTask(id) 
      case 6: SecTask(id) 
      case 7: EquipMenu(id) 
   } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public BuyMenu(id) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   new menuBody[512] 
   format(menuBody,511,"\yBuy Item^n^n\w1. Handgun^n2. Shotgun^n3. Sub-Machine Gun^n4. Rifle^n5. Machine Gun^n^n6. Primary weapon ammo^n7. Secondary weapon ammo^n^n8. Equipment^n^n0. Exit") 
   show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9)),menuBody) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public HandMenuAction(id,key) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   switch (key) 
   { 
      case 0: SecWeapon(id,CSW_USP,0) 
      case 1: SecWeapon(id,CSW_GLOCK18,1) 
      case 2: SecWeapon(id,CSW_DEAGLE,2) 
      case 3: SecWeapon(id,CSW_P228,3) 
      case 4:{ 
         if ((get_user_team(id)==2)&&BuyTeamCvar) return PLUGIN_HANDLED 
         SecWeapon(id,CSW_ELITE,4) 
      } 
      case 5:{ 
         if ((get_user_team(id)==1)&&BuyTeamCvar) return PLUGIN_HANDLED 
         SecWeapon(id,CSW_FIVESEVEN,5) 
      } 
   } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public HandMenu(id) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   new Team = get_user_team(id) 
   new menuBody[512] 
   new len = format(menuBody,511,"\yBuy Handgun\R$   Cost^n(Secondary weapon)^n^n\w1. H&K USP .45 Tactical\R\y%d^n\w2. Glock18 Select Fire\R\y%d^n\w3. Desert Eagle .50AE\R\y%d^n\w4. SIG P228\R\y%d^n",wCost[0],wCost[1],wCost[2],wCost[3]) 

   if ( (Team==1)&&(BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\w5. Dual Beretta 96G Elite\R\y%d^n\d6. FN Five-Seven\R\y%d^n^n\w0. Exit",wCost[4],wCost[5]) 
   else if ( (Team==2)&&(BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\d5. Dual Beretta 96G Elite\R\y%d^n\w6. FN Five-Seven\R\y%d^n^n\w0. Exit",wCost[4],wCost[5]) 
   else 
      len += format(menuBody[len],511-len,"\w5. Dual Beretta 96G Elite\R\y%d^n\w6. FN Five-Seven\R\y%d^n^n\w0. Exit",wCost[4],wCost[5]) 

   show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<9)),menuBody) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public ShotMenuAction(id,key) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   switch (key) 
   { 
      case 0: PrimWeapon(id,CSW_M3,6) 
      case 1: PrimWeapon(id,CSW_XM1014,7) 
   } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public ShotMenu(id) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   new menuBody[512] 
   format(menuBody,511,"\yBuy Shotgun\R$   Cost^n(Primary weapon)^n^n\w1. Benelli M3 Super\R\y%d^n\w2. Benelli XM1014\R\y%d^n^n\w0. Exit",wCost[6],wCost[7]) 
   show_menu(id,((1<<0)|(1<<1)|(1<<9)),menuBody) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public SubMenuAction(id,key) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   switch (key) 
   { 
      case 0: PrimWeapon(id,CSW_MP5NAVY,8) 
      case 1:{ 
         if ((get_user_team(id)==1)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_TMP,9) 
      } 
      case 2: PrimWeapon(id,CSW_P90,10) 
      case 3:{ 
         if ((get_user_team(id)==2)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_MAC10,11) 
      } 
      case 4: PrimWeapon(id,CSW_UMP45,12) 
   } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public SubMenu(id) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   new Team = get_user_team(id) 
   new menuBody[512] 
   new len = format(menuBody,511,"\yBuy Sub-Machine Gun\R$   Cost^n(Primary weapon)^n^n\w1. H&K MP5-Navy\R\y%d^n",wCost[8]) 

   if ( (Team==2)||(!BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\w2. Steyr Tactical Machine Pistol\R\y%d^n",wCost[9]) 
   else 
      len += format(menuBody[len],511-len,"\d2. Steyr Tactical Machine Pistol\R\y%d^n",wCost[9]) 

   len += format(menuBody[len],511-len,"\w3. FN P90\R\y%d^n",wCost[10]) 

   if ( (Team==1)||(!BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\w4. Ingram MAC-10\R\y%d^n",wCost[11]) 
   else 
      len += format(menuBody[len],511-len,"\d4. Ingram MAC-10\R\y%d^n",wCost[11]) 

   len += format(menuBody[len],511-len,"\w5. H&K UMP45\R\y%d^n^n\w0. Exit",wCost[12]) 

   show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<9)),menuBody) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public RifleMenuAction(id,key) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   switch (key) 
   { 
      case 0:{ 
         if ((get_user_team(id)==2)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_AK47,13) 
      } 
      case 1:{ 
         if ((get_user_team(id)==2)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_SG552,14) 
      } 
      case 2:{ 
         if ((get_user_team(id)==1)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_M4A1,15) 
      } 
      case 3:{ 
         if ((get_user_team(id)==1)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_AUG,16) 
      } 
      case 4: PrimWeapon(id,CSW_SCOUT,17) 
      case 5: PrimWeapon(id,CSW_AWP,18) 
      case 6:{ 
         if ((get_user_team(id)==2)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_G3SG1,19) 
      } 
      case 7:{ 
         if ((get_user_team(id)==1)&&BuyTeamCvar) return PLUGIN_HANDLED 
         PrimWeapon(id,CSW_SG550,20) 
      } 
   } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public RifleMenu(id) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   new Team = get_user_team(id) 
   new menuBody[512] 
   new len = format(menuBody,511,"\yBuy Assault Rifle (Primary weapon)\R$   Cost^n^n") 

   if ( (Team==1)||(!BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\w1. AK-47\R\y%d^n\w2. Sig SG-552 Commando\R\y%d^n",wCost[13],wCost[14]) 
   else 
      len += format(menuBody[len],511-len,"\d1. AK-47\R\y%d^n\d2. Sig SG-552 Commando\R\y%d^n",wCost[13],wCost[14]) 

   if ( (Team==2)||(!BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\w3. Colt M4A1 Carbine\R\y%d^n\w4. Steyr Aug\R\y%d",wCost[15],wCost[16]) 
   else 
      len += format(menuBody[len],511-len,"\d3. Colt M4A1 Carbine\R\y%d^n\d4. Steyr Aug\R\y%d",wCost[15],wCost[16]) 

   len += format(menuBody[len],511-len,"^n^n\yBuy Sniper Rifle (Primary weapon)^n^n\w5. Steyr Scout\R\y%d^n\w6. AI Arctic Warfare/Magnum\R\y%d^n",wCost[17],wCost[18]) 

   if ( (Team==1)||(!BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\w7. H&K G3/SG-1 Sniper Rifle\R\y%d^n",wCost[19]) 
   else 
      len += format(menuBody[len],511-len,"\d7. H&K G3/SG-1 Sniper Rifle\R\y%d^n",wCost[19]) 

   if ( (Team==2)||(!BuyTeamCvar) ) 
      len += format(menuBody[len],511-len,"\w8. Sig SG-550 Sniper\R\y%d^n^n\w0. Exit",wCost[20]) 
   else 
      len += format(menuBody[len],511-len,"\d8. Sig SG-550 Sniper\R\y%d^n^n\w0. Exit",wCost[20]) 

   show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9)),menuBody) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public MachineMenuAction(id,key) 
{ 
   if (key==0) PrimWeapon(id,CSW_M249,21) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public MachineMenu(id) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   new menuBody[512] 
   format(menuBody,511,"\yBuy Machine Gun\R$   Cost^n(Primary weapon)^n^n\w1. FN M249 Para\R\y%d^n^n\w0. Exit",wCost[21]) 
   show_menu(id,((1<<0)|(1<<9)),menuBody) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public EquipMenuAction(id,key) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   switch (key) 
   { 
      case 0:{ 
         if (get_user_armor(id)==100) return PLUGIN_HANDLED 
         if (!Money(id,24)) return PLUGIN_HANDLED 
         give_item(id,"item_kevlar") 
         KevlarHelmet[id] = false 
      } 
      case 1:{ 
         if (get_user_armor(id)==100&&KevlarHelmet[id]) return PLUGIN_HANDLED 
         if (!Money(id,25)) return PLUGIN_HANDLED 
         give_item(id,"item_assaultsuit") 
         KevlarHelmet[id] = true 
      } 
      case 2:{ 
         new weapons[32],num 
         get_user_weapons(id,weapons,num) 
         for (new i=0; i<num; i++) 
            if (weapons[i]==CSW_FLASHBANG) 
            { 
               new clip,ammo 
               get_user_ammo(id,weapons[i],clip,ammo) 
               if (clip+ammo==1) return PLUGIN_HANDLED 
            } 
         if (!Money(id,26)) return PLUGIN_HANDLED 
         give_item(id,"weapon_flashbang") 
      } 
      case 3:{ 
         new weapons[32],num 
         get_user_weapons(id,weapons,num) 
         for (new i=0; i<num; i++) 
            if (weapons[i]==CSW_HEGRENADE) return PLUGIN_HANDLED 
         if ( BuyGrenadesCvar>0 && BuyGrenadesCvar==BuyProtect[id] ) 
         { 
            new Gren[2] 
            if (BuyGrenadesCvar==1) copy(Gren,1,"") 
            else copy(Gren,1,"s") 
            client_print(id,print_center,"You can only buy %d HE Grenade%s per round!",BuyGrenadesCvar,Gren) 
            return PLUGIN_HANDLED 
         } 
         if (!Money(id,27)) return PLUGIN_HANDLED 
         give_item(id,"weapon_hegrenade") 
         BuyProtect[id]++ 
      } 
      case 4:{ 
         new weapons[32],num 
         get_user_weapons(id,weapons,num) 
         for (new i=0; i<num; i++) 
            if (weapons[i]==CSW_SMOKEGRENADE) return PLUGIN_HANDLED 
         if (!Money(id,28)) return PLUGIN_HANDLED 
         give_item(id,"weapon_smokegrenade") 
      } 
      case 5:{ 
         if ( (get_user_team(id)==1&&BuyTeamCvar)||!DeMap||DefuseKit[id] ) return PLUGIN_HANDLED 
         if (!Money(id,29)) return PLUGIN_HANDLED 
         give_item(id,"item_thighpack") 
      } 
      case 6:{ 
         if (NightVision[id]) return PLUGIN_HANDLED 
         if (!Money(id,30)) return PLUGIN_HANDLED 
         NightVision[id] = true 
      } 
   } 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public EquipMenu(id) 
{ 
   if (!Check(id)) return PLUGIN_CONTINUE

   new Team = get_user_team(id) 
   new cMap[32] 
   get_mapname(cMap,31) 
   new menuBody[512] 
   new len = format(menuBody,511,"\yBuy Equipment\R$   Cost^n^n\w1. Kevlar Vest\R\y%d^n\w2. Kevlar Vest & Helmet\R\y%d^n\w3. Flashbang\R\y%d^n",wCost[24],wCost[25],wCost[26]) 

   if ( BuyGrenadesCvar>0 && BuyGrenadesCvar==BuyProtect[id] ) 
      len += format(menuBody[len],511-len,"\d4. HE Grenade\R\y%d^n",wCost[27]) 
   else 
      len += format(menuBody[len],511-len,"\w4. HE Grenade\R\y%d^n",wCost[27]) 
    
   len += format(menuBody[len],511-len,"\w5. Smoke Grenade\R\y%d^n",wCost[28]) 

   if ( ((Team==2)||(!BuyTeamCvar))&&equali(cMap,"de_",3) ) 
      len += format(menuBody[len],511-len,"\w6. Defuse Kit\R\y%d^n",wCost[29]) 
   else 
      len += format(menuBody[len],511-len,"\d6. Defuse Kit\R\y%d^n",wCost[29]) 
   if (!NightVision[id])
      len += format(menuBody[len],511-len,"\w7. NightVision Goggles\R\y%d^n^n\w0. Exit",wCost[30]) 
   else
      len += format(menuBody[len],511-len,"\d7. NightVision Goggles\R\y%d^n^n\w0. Exit",wCost[30]) 
   show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<9)),menuBody) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public setCost() // default costs 
{ 
   wCost[0] = 500      // 11: H&K USP .45 Tactical (CSW_USP) 
   wCost[1] = 400      // 12: Glock18 Select Fire (CSW_GLOCK18) 
   wCost[2] = 650      // 13: Desert Eagle .50AE (CSW_DEAGLE) 
   wCost[3] = 600      // 14: SIG P228 (CSW_P228) 
   wCost[4] = 1000      // 15: Dual Beretta 96G Elite (CSW_ELITE) 
   wCost[5] = 750      // 16: FN Five-Seven (CSW_FIVESEVEN) 

   wCost[6] = 1700      // 21: Benelli M3 Super (CSW_M3) 
   wCost[7] = 3000      // 22: Benelli XM1014 (CSW_XM1014) 

   wCost[8] = 1500      // 31: H&K MP5-Navy (CSW_MP5NAVY) 
   wCost[9] = 1250      // 32: Steyr Tactical Machine Pistol (CSW_TMP) 
   wCost[10] = 2350   // 33: FN P90 (CSW_P90) 
   wCost[11] = 1400   // 34: Ingram MAC-10 (CSW_MAC10) 
   wCost[12] = 2350   // 35: H&K UMP45 (CSW_UMP45) 

   wCost[13] = 2500   // 41: AK-47 (CSW_AK47) 
   wCost[14] = 3500   // 42: Sig SG-552 Commando (CSW_SG552) 
   wCost[15] = 3100   // 43: Colt M4A1 Carbine (CSW_M4A1) 
   wCost[16] = 3500   // 44: Steyr Aug (CSW_AUG) 
   wCost[17] = 2750   // 45: Steyr Scout (CSW_SCOUT) 
   wCost[18] = 4750   // 46: AI Arctic Warfare/Magnum (CSW_AWP) 
   wCost[19] = 5000   // 47: H&K G3/SG-1 Sniper Rifle (CSW_G3SG1) 
   wCost[20] = 4200   // 48: Sig SG-550 Sniper (CSW_SG550) 

   wCost[21] = 5750   // 51: FN M249 Para (CSW_M249) 

   wCost[22] = 30      // 61: Primary Ammo 

   wCost[23] = 25      // 71: Secondary Ammo 

   wCost[24] = 650      // 81: Kevlar Vest 
   wCost[25] = 1000   // 82: Kevlar Vest & Helmet 
   wCost[26] = 200      // 83: Flashbang 
   wCost[27] = 300      // 84: HE Grenade 
   wCost[28] = 300      // 85: Smoke Grenade 
   wCost[29] = 200      // 86: Defuse Kit 
   wCost[30] = 1250   // 87: NightVision Goggles 
} 
//---------------------------------------------------------------------------------------------- 
public Restart_Round() 
{ 
   new players[32],num 
   get_players(players,num,"a") 
   for (new i=0; i<num; i++) 
      NightVision[players[i]] = false // nobody can use NightVision now

   return PLUGIN_CONTINUE 
} 
//---------------------------------------------------------------------------------------------- 
public ToggleNVG(id) 
{ 
   if (!gHasBillGatesPowers[id]) return PLUGIN_CONTINUE
   if (!NightVision[id]) return PLUGIN_CONTINUE
   if (NightVisionUse[id]) StopNVG(id) 
   else StartNVG(id) 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public StartNVG(id) // NightVision code by Lazy (a little bit modified) 
{ 
   new player[32] 
   get_user_name(id,player,32) 

   emit_sound(id,CHAN_ITEM,"items/nvg_on.wav",1.0,ATTN_NORM,0,PITCH_NORM) 
   set_task(0.1,"RunNVG",id+100,player,32,"b") // another task id for each player 
   set_task(0.1,"RunNVG2",id+200,player,32,"b") 
   NightVisionUse[id] = true 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public StopNVG(id) 
{ 
   emit_sound(id,CHAN_ITEM,"items/nvg_off.wav",1.0,ATTN_NORM,0,PITCH_NORM) 

   remove_task(id+100) 
   remove_task(id+200) 
   NightVisionUse[id] = false 

   return PLUGIN_HANDLED 
} 
//---------------------------------------------------------------------------------------------- 
public RunNVG(player[]) 
{ 
      new id = get_user_index(player) 
      new origin[3] 
      get_user_origin(id,origin) 

      message_begin(MSG_ONE,SVC_TEMPENTITY,{0,0,0},id) 

      write_byte(27) 

      write_coord(origin[0]) 
      write_coord(origin[1]) 
      write_coord(origin[2]) 

      write_byte(125) 

      write_byte(0) 
      write_byte(255) 
      write_byte(0) 

      write_byte(1) 
      write_byte(10) 

      message_end() 
} 
//---------------------------------------------------------------------------------------------- 
public RunNVG2(player[]) 
{ 
   new id = get_user_index(player) 

   message_begin(MSG_ONE,gmsgFade,{0,0,0},id) 

   write_short(1000) 
   write_short(1000) 
   write_short(1<<12) 

   write_byte(0) 
   write_byte(255) 
   write_byte(0) 

   write_byte(150) 

   message_end() 
} 
//----------------------------------------------------------------------------------------------